#ifndef __MY_DISPLAYUNIT_H
#define __MY_DISPLAYUNIT_H
#include <stdint.h>
#include <string.h>

typedef void (*uiFuntion) (int agr0, void *agr1_ptr);
typedef void (*enterCallback) (int agr0, int agr1, int agr2, int agr3);
typedef void (*pageChangeCallback) (int agr0, int agr1, int agr2, int agr3);
typedef enum
{
    UI_PAGE_ID_FIRST_UI,
    UI_PAGE_ID_ITEM_MODE,
    UI_PAGE_ID_TX_PACKET,
    UI_PAGE_ID_RX_PACKET,
    UI_PAGE_ID_RF_CONTINUOUS,
    UI_PAGE_ID_SETTING,
    UI_PAGE_ID_MAX,
}uiPageIndex_te;
typedef enum
{
    MD_ITEM_INDX_TX_PACKET,
    MD_ITEM_INDX_RX_PACKET,
    MD_ITEM_INDX_CONTINUOUS,
    MD_ITEM_INDX_SETTING,
    MD_ITEM_INDX_MAX,
}modeItemIndex_te;
typedef enum
{
    ENTER_NEXT_PAGE,
    ENTER_LAST_PAGE,
    ENTER_CURRENT_PAGE,
    ENTER_RELEASE_PAGE,
}enter_te;
typedef enum
{
    TYPE_GERNERL_TEXT,
    TYPE_WRITE_TEXT,
    TYPE_NEXT_LINK,
}itemType_te;
typedef struct 
{
    int cursorCount;            //ܹƶ
    int cursorCounting;         //Ĺƶ
    uiFuntion uiDriver;         //ʾ
    int id;                     //ID
    int lastPageIdTab[6];       //һ泬ӣӦID
    int nextPageIdTab[6];       //һ泬ӣӦID
    int itemValueTab[6];        //дֵ
    int itemMaxValueTab[6];     //дֵ
    itemType_te itemTypeTab[6]; //=0ͨı=1ɱ༭ı=2һ泬
    uint8_t writeStaTab[6];     //д״̬=1ͨ°Ӽͬʱ򱳾˸
    uint8_t writeStatusTab[6];  //Ƹ򱳾ɫ
}uiPageUnit_ts;

int8_t myDisplay_getPageId(void);
void myDisplay_enter(uint8_t direct);
void myDisplay_change(uint8_t direct);
void myDisplay_ui_rf_continuos_txCurrent(float Current);
void myDisplay_ui_rf_tx_packet_buffer(uint8_t *buffer);
void myDisplay_ui_rf_continuos_rxErrorRate(float rate);
void myDisplay_ui_rf_continuos_rxContinuousFreq(uint32_t freq);
void myDisplay_ui_rf_continuos_rxPacket(uint8_t *buf, uint16_t len);
void myDisplay_ui_rf_continuos_rxPacketCount(uint8_t status, uint16_t count);
void myDisplay_ui_rf_continuos_rxPacketGetCount(uint32_t count);
void myDisplay_ui_rf_rxPacket_buffer(uint8_t *buf, uint16_t len);
void myDisplay_ui_rf_rxPacket_rssi(int8_t rssi, int8_t snr);
void myDisplay_ui_rf_rxPacket_rate(float rate, int count, int frame);
void myDisplay_ui_rf_rxPacket_rxCurrent(float current);
void myDisplay_ui_firstUi_setDeviceName(char *name);
void myDisplay_ui_firstUi_setFreq(uint32_t freq);
void myDisplay_init(enterCallback cb);
void myDisplay_ui_firstUi_setRfPower(int power);
void myDisplay_setSettingParams(int agr0, int agr1, int agr2);
void myDisplay_ui_rf_setting_freq(uint32_t freq);
void myDisplay_ui_rf_setting_type(char *type);
void uiTimerFlash_callBack(void);
#endif

